c     costruisce data set giornaliero sp500
      real mm[allocatable] (:,:),
     *     m [allocatable] (:,:),  lune [allocatable] (:),
     *     giorno [allocatable] (:,:),
     *     vPerc [allocatable] (:), vSegno [allocatable] (:),
     *     desm [allocatable] (:),  mome [allocatable] (:),
     *     rmm [allocatable] (:),   maxmin [allocatable] (:),
     *     out [allocatable] (:,:), prev [allocatable] (:),
     *     v [allocatable] (:)
     
      ic_g=7         ! il num. del g. nella sett. (2=lun. ecc.) sta a col.7 
      ic_chiu=6      ! il valore di chiusura sta a col. 6
      open(1,file=' ')
      open(2,file='elab.dat')

      read(1,*)nr,nc
      
      allocate (mm(nr,nc),
     *          m(nr,nc), giorno(nr,5), 
     *          lune(nr), vPerc(nr), vSegno(nr), desm(nr),
     *          mome(nr), rmm(nr), maxmin(nr), out(nr,11), prev(nr),
     *          v(nr),
     *          stat=ier)    

      if(ier.ne.0)then
                      write(*,*)"Insufficiente spazio per le matrici"
                      stop 99
                      end if
                      
      do 10 i=1,nr
10    read(1,*)(mm(i,j),j=1,nc)      

c     gestione date
      call date(mm,m,nr,nc,nrr)
      
c     dummy lunedi' e altri giorni
      do 20 i=1,nrr      
      do 21 j=1,5
      giorno(i,j)=0
21    if(m(i,ic_g).eq.j+1)giorno(i,j)=1      
      lune(i)=0
20    if(m(i,ic_g).eq.2)lune(i)=1
      
c     variazioni percentuali chiusura
      vPerc(1)=0
      do 30 i=2,nrr
30    vPerc(i)=100.*(m(i,ic_chiu)-m(i-1,ic_chiu))/m(i-1,ic_chiu)
      
c     segno variazione percentuale (0 - ; 1 +)
      vSegno(0)=0
      do 40 i=1,nrr
      vSegno(i)=0
40    if(vPerc(i).ge.0)vSegno(i)=1

c     stima della variazione standard
      interv=20
      do 49 i=1,interv
49    desm(i)=0      
      do 50 i=interv+1,nrr
      s2=0
      s=0
      do 51 ii=0,19
      s=s+vPerc(i-ii)
51    s2=s2+vPerc(i-ii)**2
      s=(s/interv)**2
      s2=s2/interv
50    desm(i)=sqrt(s2-s)     

c     indicatore di momento
      intMome=10
      do 59 i=1,intMome
59    mome(i)=0      
      do 60 i=intMome+1,nrr
60    mome(i)=m(i,ic_chiu)/m(i-intMome,ic_chiu)

c     rapporto medie mobili livelli
      me90=90
      me5=5                       
      do 69 i=1,me90-1
69    rmm(i)=0
      do 70 i=me90,nrr
      tme90=0
      tme5=0
      do 71 j=0,me90-1
71    tme90=tme90+m(i-j,ic_chiu)
      do 72 j=0,me5-1
72    tme5=tme5+m(i-j,ic_chiu)
70    rmm(i)=(tme5/me5)/(tme90/me90)          

c     livello tra min e max a 30 g
      ig30=30
      do 79 i=1,ig30-1
79    maxmin(i)=0    
      do 80 i=ig30,nrr  
      vmax=0
      vmin=1000000     
      do 81 j=0,ig30-1
      if(m(i-j,ic_chiu).gt.vmax)vmax=m(i-j,ic_chiu)
81    if(m(i-j,ic_chiu).lt.vmin)vmin=m(i-j,ic_chiu)
80    maxmin(i)=(m(i,ic_chiu)-vmin)/(vmax-vmin)               
      
c     calcolo dei valori da prevedere
c     variazioni % a 1, 5, 10,20 g.
c     segni di tali variazioni
c     medie delle variazioni % dei singoli giorni sino a 5, 10, 20 g.

c     var %
      do 90 i=1,nrr-20
      out(i,1)=100*(m(i+ 1,ic_chiu)-m(i,ic_chiu))/m(i,ic_chiu)
      out(i,2)=100*(m(i+ 5,ic_chiu)-m(i,ic_chiu))/m(i,ic_chiu)
      out(i,3)=100*(m(i+10,ic_chiu)-m(i,ic_chiu))/m(i,ic_chiu)
90    out(i,4)=100*(m(i+20,ic_chiu)-m(i,ic_chiu))/m(i,ic_chiu)
      do 91 i=nrr-19,nrr
      do 91 k=1,4
91    out(i,k)=0   

c     segno della var. % (0 - ; 1 +)
      do 100 i=1,nrr-20
      do 100 k=5,8
      out(i,k)=0
100   if(out(i,k-4).ge.0)out(i,k)=1.
      do 101 i=nrr-19,nrr
      do 101 k=5,8
101   out(i,k)=0 

c     media delle variazioni giornaliere
      do 105 i=1,nrr-20
      
      out(i, 9)=0
      do 109 k=1,5
109   out(i, 9)=out(i, 9)+100*(m(i+k  ,ic_chiu)-m(i+k-1,ic_chiu))/
     *                         m(i+k-1,ic_chiu)
      out(i, 9)=out(i, 9)/5

      out(i,10)=0
      do 110 k=1,10
110   out(i,10)=out(i,10)+100*(m(i+k  ,ic_chiu)-m(i+k-1,ic_chiu))/
     *                         m(i+k-1,ic_chiu)
      out(i,10)=out(i,10)/10

      out(i,11)=0
      do 111 k=1,20
111   out(i,11)=out(i,11)+100*(m(i+k  ,ic_chiu)-m(i+k-1,ic_chiu))/
     *                         m(i+k-1,ic_chiu)
      out(i,11)=out(i,11)/20

105   continue                        
      do 106 i=nrr-19,nrr
      do 106 k=9,11
106   out(i,k)=0               

c     gestione output scegliendo la variabile da prevedere
399   write(6,400)
400   format(' Quale variabile in output?',/,
     *       '                 1 - var. % a  1 g.',/,
     *       '                 2 - var. % a  5 g.',/,
     *       '                 3 - var. % a 10 g.',/,
     *       '                 4 - var. % a 20 g.',/,
     *       '                 5 - segno var. % a  1 g.',/,
     *       '                 6 - segno var. % a  5 g.',/,
     *       '                 7 - segno var. % a 10 g.',/,
     *       '                 8 - segno var. % a 20 g.',/,
     *       '                 9 - media var. % giornal. a  5 g.',/,
     *       '                10 - media var. % giornal. a 10 g.',/,
     *       '                11 - media var. % giornal. a 20 g.')
                                
      read(5,*)ivar
      if(ivar.lt.1.or.ivar.gt.11)go to 399                       
      do 401 i=1,nrr
401   prev(i)=out(i,ivar)

c     eliminazione dei valori eccezionali
      write(6,402)
402   format(' Coeff. da applicare alla st.dev. del valore da ',
     *       'prevedere per eliminare',/' i valori eccezionali') 
      read(5,*)coeff          
      
7990  write(6,8000)
8000  format(' L''eliminazione degli outliers si applica al'
     *       ' valore di out. (prev.)? (0=n; 1=s)')
      read(5,*)isn
      if(isn.ne.0.and.isn.ne.1) go to 7990       
      if(isn.eq.1) then
       s2=0
       s=0
       do 403 i=me90,nrr-20
       s=s+prev(i)
403    s2=s2+prev(i)**2
       k=nrr-20-me90+1
       am=s/k
       s=(s/k)**2
       s2=s2/k
       std=sqrt(s2-s)
       do 404 i=1,nrr
404    if(abs(prev(i)-am).gt.coeff*std)prev(i)=99999.    
      end if
      
799   write(6,800)
800   format(' L''eliminazione degli outliers si applica ai'
     *       ' valori di input? (0=n; 1=s)')
      read(5,*)isn
      if(isn.ne.0.and.isn.ne.1) go to 799       
      if(isn.eq.1) then
       call stdsub(desm  ,nr,nrr,coeff,me90,prev)
       call stdsub(mome  ,nr,nrr,coeff,me90,prev)
       call stdsub(rmm   ,nr,nrr,coeff,me90,prev)
       call stdsub(maxmin,nr,nrr,coeff,me90,prev)
       do 801 k=0,4
       do 811 i=1,nrr
811    v(i)=0
       do 812 i=me90,nrr-20
812    v(i)=vPerc(i-k)       
801    call stdsub(v     ,nr,nrr,coeff,me90,prev)  
      end if
      
                                          
c     quale giorno in output
555   write(6,500)
500   format(' Quale giorno in output?'
     *      ,' -1=tutti con 5 dummy; 0=tutti; 2=lun., 3=mar. ecc.')
      read(5,*)igio      
      if(igio.eq.1.or.igio.lt.-1.or.igio.gt.6)go to 555
                                                 
c     output variabili tecniche
c     output ritardato dei valori vPerc -4,-3,-2,-1; del valore del g.
c     output del valore da prevedere
      
      ic=0                              
      do 300 i=me90,nrr-20
       if(prev(i).ne.99999..and.(igio.le.0.or.igio.eq.m(i,ic_g))) then
       
       if(igio.eq.0)write(2,301)
     * lune(i),vSegno(i),desm(i),mome(i),rmm(i),maxmin(i),
     * (vPerc(i-k),k=4,0,-1),
     * prev(i)
301    format(1x,f2.0,1x,f2.0,1x,f8.4,1x,f8.4,1x,f8.4,1x,f8.4,
     *        5(1x,f8.4),1x,f8.4)

       if(igio.gt.0)write(2,302)
     *         vSegno(i),desm(i),mome(i),rmm(i),maxmin(i),
     * (vPerc(i-k),k=4,0,-1),
     * prev(i)
302    format(1x,2x  ,1x,f2.0,1x,f8.4,1x,f8.4,1x,f8.4,1x,f8.4,
     *        5(1x,f8.4),1x,f8.4)

       if(igio.eq.-1)write(2,303)
     * (giorno(i,j),j=1,5),vSegno(i),desm(i),mome(i),rmm(i),maxmin(i),
     * (vPerc(i-k),k=4,0,-1),
     * prev(i)
303    format(5f3.0,2x,f2.0,1x,f8.4,1x,f8.4,1x,f8.4,1x,f8.4,
     *        5(1x,f8.4),1x,f8.4)

       ic=ic+1
      end if
300   continue
      
      close(2)       
      write(6,600)ic
600   format(' Record scritti: ',i5)             
      stop
      end           
      
      
      subroutine stdsub(x,nr,nrr,c,me,p)
      real x(nr), p(nr)
      s2=0
      s=0
      do 403 i=me,nrr-20
      s=s+x(i)
403   s2=s2+x(i)**2
      k=nrr-20-me+1
      am=s/k
      s=(s/k)**2
      s2=s2/k
      std=sqrt(s2-s)                   
      do 404 i=1,nrr
404   if(abs(x(i)-am).gt.c*std)p(i)=99999.    
      return
      end


      subroutine date(mm,m,nr,nc,nrr)
      real mm(nr,nc), m(nr,nc)      
      
      nrr=nr
          
      write(*,100)
100   format(' Intervallo di tempo da elaborare (date=AAMMGG)',/
     *       ' da (-1=tutti i dati; 0=dall''inizio)')
      read(*,*)idata0               
      
      if(idata0.eq.-1)then
          
         do 1 i=1,nr
         do 1 j=1,nc
1        m(i,j)=mm(i,j) 

      else                   
      
         idata1=-1
         write(*,101)
101      format(' sino a (0=sino alla fine)')
         read(*,*)idata1
         if(idata1.eq.0)idata1=1000000
         if(idata1.lt.idata0) stop"data finale minore data iniziale"
                       
         nrr=0
         do 2 i=i,nr
         idata=(mm(i,1)-1900)*10000+mm(i,2)*100+mm(i,3)
         if(idata.ge.idata0.and.idata.le.idata1) then
             nrr=nrr+1
             do 22 j=1,nc
22           m(nrr,j)=mm(i,j)
             end if             
2        continue        

               
      end if
      return
      end 
